schedule function bastion_raid:1t 1t

#DEATH ITEM WHITELIST
execute as @a[scores={bastion_raid.die=1..}] at @s run execute as @e[type=wither_skeleton,tag=bastion_raid.entity,sort=random] at @s run tag @e[type=item,tag=!bastion_raid.imp,distance=..64] add bastion_raid.imp
scoreboard players reset @a[scores={bastion_raid.die=1..}] bastion_raid.cur
scoreboard players reset @a[scores={bastion_raid.die=1..}] bastion_raid.die

#SPAWN EGG COMMAND
execute as @e[type=area_effect_cloud,tag=bastion_raid.captain_spawn] at @s run function summon:bastion_raid/captain
execute as @e[type=area_effect_cloud,tag=bastion_raid.captain_spawn] at @s run kill @s
execute as @e[type=area_effect_cloud,tag=bastion_raid.raider_spawn] at @s run function summon:bastion_raid/raider
execute as @e[type=area_effect_cloud,tag=bastion_raid.raider_spawn] at @s run kill @s
execute as @e[type=area_effect_cloud,tag=bastion_raid.golem_spawn] at @s run function summon:bastion_raid/bastion_golem
execute as @e[type=area_effect_cloud,tag=bastion_raid.golem_spawn] at @s run kill @s

#DIGGER CODE
execute as @e[type=vex,tag=bastion_raid.digger] at @s run tp @s ^ ^ ^0.5 facing entity @e[tag=bastion_raid.target,limit=1,sort=nearest] feet
execute as @e[type=vex,tag=bastion_raid.digger] at @s run fill ~0.5 ~0.5 ~0.5 ~-0.5 ~-0.5 ~-0.5 air replace #bastion_raid:bastion_blocks
execute as @e[type=vex,tag=bastion_raid.digger] at @s run particle block{block_state:"minecraft:blackstone"} ~ ~ ~ 0.5 0.5 0.5 1 0 normal
execute as @e[type=vex,tag=bastion_raid.digger] at @s run playsound block.stone.break block @a ~ ~ ~
execute as @e[type=vex,tag=bastion_raid.digger] at @s run execute unless entity @e[tag=bastion_raid.target,distance=..128] run function bastion_raid:delete_current_entity
execute as @e[type=vex,tag=bastion_raid.digger] at @s run execute if entity @e[tag=bastion_raid.target,distance=..1] run function bastion_raid:delete_current_entity

#BASTION GOLEM IMMUNE TO WITHER
effect clear @e[type=iron_golem,tag=bastion_raid.golem] wither

#BASTION GOLEM HURT SOUND
execute as @e[type=iron_golem,tag=bastion_raid.golem,nbt={HurtTime:9s}] at @s run playsound entity.iron_golem.hurt neutral @a ~ ~ ~

#BASTION GOLEM DEATH SOUND
execute as @e[type=item,nbt={Item:{components:{"minecraft:custom_data":{bastion_raid.golem_death:1b}}}}] at @s run playsound entity.iron_golem.death neutral @a ~ ~ ~
kill @e[type=item,nbt={Item:{components:{"minecraft:custom_data":{bastion_raid.golem_death:1b}}}}]

#DISPLAY MESSAGE TO PLAYER
execute as @a[tag=bastion_raid.cur,scores={bastion_raid.cur=1..}] at @s run title @s actionbar [{"text": "Wither Omen Effect: ","color": "gray","bold": true},{"text": " 1 hour, 40 minutes","color": "white","bold": false}]

#PARTICLES DISPLAY
execute as @a[gamemode=!spectator,scores={bastion_raid.cur=1..}] at @s run particle dust{color:[0.129,0.129,0.129],scale:1} ~ ~1 ~ 0.25 0.5 0.25 10 3 normal @s

#TAG VANILLA PIGLINS
tag @e[type=#bastion_raid:piglins,tag=!smithed.entity,tag=!smithed.strict] add bastion_raid.piglins
team join piglin @e[type=#bastion_raid:piglins,tag=bastion_raid.piglins,team=]
function bastion_raid:patch/1

#WITHER SKELETON RAIDER HEALTHBAR
scoreboard players reset bastion_raid.sc bastion_raid.hp
execute as @e[type=wither_skeleton,tag=bastion_raid.raider] at @s run function bastion_raid:bossbar/value
execute as @e[type=wither_skeleton,tag=bastion_raid.raider,limit=1] at @s run execute store result bossbar bastion_raid:raid value run scoreboard players get bastion_raid.sc bastion_raid.hp

#DIFFICULTY SCOREBOARD
execute store result score bastion_raid.sc bastion_raid.dif run difficulty

#RAIDED BASTION REPLACE MOBS WITH FORTRESS MOBS
execute as @e[type=#bastion_raid:replaceable,tag=!bastion_raid.tagged,tag=!smithed.entity,tag=!smithed.strict,predicate=bastion_raid:location/bastion] at @s run execute if entity @e[type=wither_skeleton,tag=bastion_raid.captain,predicate=bastion_raid:location/bastion,distance=..128] run execute unless entity @e[type=#bastion_raid:piglins,tag=bastion_raid.target,predicate=bastion_raid:location/bastion,distance=..128] run execute unless entity @a[gamemode=!spectator,distance=..8] run function bastion_raid:replace/fortress_mob
#RAIDED BASTION REMOVE MOBS NEARBY
execute as @e[type=#bastion_raid:replaceable,tag=!bastion_raid.tagged,tag=!smithed.entity,tag=!smithed.strict,predicate=!bastion_raid:location/bastion] at @s run execute if entity @e[type=wither_skeleton,tag=bastion_raid.captain,predicate=bastion_raid:location/bastion,distance=..128] run execute unless entity @e[type=#bastion_raid:piglins,tag=bastion_raid.target,predicate=bastion_raid:location/bastion,distance=..128] run execute unless entity @a[gamemode=!spectator,distance=..8] run function bastion_raid:delete_current_entity
#DURING RAID PIGLINS WILL NEVER SPAWN
execute as @e[type=#bastion_raid:piglins,tag=!bastion_raid.tagged,tag=bastion_raid.piglins] at @s run execute unless entity @a[gamemode=!spectator,distance=..8] run execute if score bastion_raid.sc bastion_raid.vis matches 1 run function bastion_raid:restrict/piglin
#ADD TAG
tag @e[type=#bastion_raid:replaceable,tag=!bastion_raid.tagged,tag=!smithed.entity,tag=!smithed.strict] add bastion_raid.tagged

#DELETE MAGMA CUBE FROM BASTION
execute as @e[type=magma_cube,predicate=bastion_raid:location/bastion,tag=!bastion_raid.tagged,tag=!smithed.entity,tag=!smithed.strict] at @s run execute unless entity @a[gamemode=!spectator,distance=..8] run function bastion_raid:delete_current_entity
tag @e[type=magma_cube,tag=!bastion_raid.tagged,tag=!smithed.entity,tag=!smithed.strict] add bastion_raid.tagged

#MOB DISCOVER: BASTION GOLEM
execute as @a[gamemode=!spectator,advancements={bastion_raid:mob_discover/bastion_golem=false}] at @s run execute if entity @e[type=iron_golem,tag=bastion_raid.golem,distance=..2] run advancement grant @s only bastion_raid:mob_discover/bastion_golem

#REMOVE FIRE FROM WITHER SKELETON ARROWS
execute as @e[type=wither_skeleton,tag=bastion_raid.nofire,nbt={HandItems:[{id:"minecraft:bow"},{}]}] at @s run execute if entity @e[type=arrow,tag=!bastion_raid.nofire,tag=!smithed.entity,nbt={pickup:0b},distance=..3] run function bastion_raid:nofire

#MAX WAVE ACCORDING TO DIFFICULTY
execute if score bastion_raid.sc bastion_raid.dif matches 0 run scoreboard players set bastion_raid.sc bastion_raid.mwv 0
execute if score bastion_raid.sc bastion_raid.dif matches 1 run scoreboard players set bastion_raid.sc bastion_raid.mwv 6
execute if score bastion_raid.sc bastion_raid.dif matches 2 run scoreboard players set bastion_raid.sc bastion_raid.mwv 7
execute if score bastion_raid.sc bastion_raid.dif matches 3 run scoreboard players set bastion_raid.sc bastion_raid.mwv 8

#REPLACE PIGLIN BRUTE WITH "PIGLIN" BRUTE
execute as @e[type=piglin_brute,tag=bastion_raid.brute,predicate=bastion_raid:angryat/player] at @s run function bastion_raid:spawn/piglin_brute
execute as @e[type=piglin_brute,tag=bastion_raid.brute,predicate=bastion_raid:angryat/player] at @s run function bastion_raid:delete_current_entity

#REPLACE "PIGLIN" BRUTE WITH PIGLIN BRUTE
execute as @e[type=piglin,tag=bastion_raid.brute,predicate=bastion_raid:angryat/zombified] at @s run function bastion_raid:spawn/real_brute
execute as @e[type=piglin,tag=bastion_raid.brute,predicate=bastion_raid:angryat/zombified] at @s run function bastion_raid:delete_current_entity

#PIGLIN NO ANGER DURING RAID
execute as @e[type=#bastion_raid:piglins,tag=bastion_raid.target,predicate=bastion_raid:angryat/player] at @s run data remove entity @s Brain.memories."minecraft:angry_at"

#PIGLINS CALM DOWN, ITS HERO
execute as @e[type=#bastion_raid:piglins,tag=bastion_raid.piglins,predicate=bastion_raid:angryat/friend] at @s run data remove entity @s Brain.memories."minecraft:angry_at"

#RAID SPAWNER DETECTED
execute as @e[type=area_effect_cloud,tag=bastion_raid.spawner,sort=random,limit=1] at @s run execute if entity @e[type=#bastion_raid:piglins,tag=bastion_raid.target,distance=..64] run execute unless entity @e[type=wither_skeleton,tag=bastion_raid.entity] run function bastion_raid:bossbar/init

#BOSSBAR ADD PLAYERS TO BASTION_RAID.MEM
execute as @e[type=area_effect_cloud,tag=bastion_raid.spawner] at @s run scoreboard players set @a[distance=..64] bastion_raid.mem 1
execute as @e[type=wither_skeleton,tag=bastion_raid.entity] at @s run scoreboard players set @a[distance=..64] bastion_raid.mem 1
execute as @e[type=#bastion_raid:piglins,tag=bastion_raid.target] at @s run scoreboard players set @a[distance=..64] bastion_raid.mem 1

#RAIDERS SWIM
execute as @e[type=wither_skeleton,tag=bastion_raid.raider] at @s run execute if block ~ ~1 ~ lava run tp @s ^ ^0.2 ^0.2
execute as @e[type=wither_skeleton,tag=bastion_raid.raider] at @s run execute if block ~ ~ ~ lava run execute unless block ~ ~-1 ~ lava run tp @s ^ ^ ^0.2

#BOSSBAR REMOVE PLAYERS FROM BASTION_RAID.MEM
execute as @a[scores={bastion_raid.mem=1},predicate=!bastion_raid:location/bastion] at @s run execute unless entity @e[type=area_effect_cloud,tag=bastion_raid.spawner,distance=..64] unless entity @e[type=wither_skeleton,tag=bastion_raid.entity,distance=..64] run execute unless entity @e[type=#bastion_raid:piglins,tag=bastion_raid.target,distance=..64] run scoreboard players reset @s bastion_raid.mem

#BOSSBAR SET MEMBERS AS BASTION_RAID.MEM
bossbar set bastion_raid:raid players @a[scores={bastion_raid.mem=1}]

#BASTION_RAID.TARGET TAG FOR PLAYERS
tag @a[gamemode=!creative,gamemode=!spectator,tag=!bastion_raid.target,predicate=bastion_raid:location/bastion] add bastion_raid.target
tag @a[tag=bastion_raid.target,predicate=!bastion_raid:location/bastion] remove bastion_raid.target
tag @a[gamemode=!survival,gamemode=!adventure,tag=bastion_raid.target,predicate=bastion_raid:location/bastion] remove bastion_raid.target

##DISABLE NAME TAGGING
#CAPTAIN WITHER SKELETON
execute as @e[type=wither_skeleton,tag=bastion_raid.cpt,name=!"Captain Wither Skeleton"] at @s run data merge entity @s {CustomName:'{"text": "Captain Wither Skeleton","color": "dark_red"}'}
execute as @e[type=wither_skeleton,tag=!bastion_raid.cpt,name="Captain Wither Skeleton"] at @s run data merge entity @s {CustomName:'{"text": "Captain Wither skeleton"}'}

#BASTION GOLEM
execute as @e[type=iron_golem,tag=bastion_raid.golem,name=!"Bastion Golem"] at @s run data merge entity @s {CustomName:'{"text": "Bastion Golem"}'}
execute as @e[type=iron_golem,tag=!bastion_raid.golem,name="Bastion Golem"] at @s run data merge entity @s {CustomName:'{"text": "Bastion golem"}'}