schedule function bastion_raid:5s 5s

#FORTRESS MOBS SPAWN IN RAIDED BASTIONS
scoreboard players reset @e[type=wither_skeleton,tag=bastion_raid.captain]
execute as @e[type=wither_skeleton,tag=bastion_raid.captain,predicate=bastion_raid:location/bastion,limit=10,sort=random] at @s run execute store result score @s bastion_raid.num run execute if entity @e[type=#bastion_raid:fortress_mob,tag=!smithed.entity,tag=!bastion_raid.captain,predicate=bastion_raid:location/bastion,limit=40,distance=..128]
execute as @e[type=wither_skeleton,tag=bastion_raid.captain,predicate=bastion_raid:location/bastion,limit=10,sort=random,scores={bastion_raid.num=1..39}] at @s run execute unless entity @e[type=#bastion_raid:piglins,tag=bastion_raid.target,distance=..128] run execute unless entity @a[gamemode=!spectator,distance=..64] run function bastion_raid:spawn/fortress_mob

#SUMMON DIGGER
execute as @e[type=wither_skeleton,tag=bastion_raid.raider,limit=1,sort=random] at @s run execute if entity @e[type=#bastion_raid:piglins,tag=bastion_raid.target,distance=..128] run execute unless entity @e[type=vex,tag=bastion_raid.digger,distance=..128] run function bastion_raid:spawn/digger

#DELETE ACTIONBAR TEXT
tag @a[tag=bastion_raid.cur,tag=!bastion_raid.cur1] remove bastion_raid.cur
tag @a[tag=bastion_raid.cur,tag=bastion_raid.cur1] remove bastion_raid.cur1

#CONVERT OTHER WITHER SKELETONS INTO RAIDER
execute if score bastion_raid.sc bastion_raid.vis matches 1 run execute as @e[type=wither_skeleton,tag=!bastion_raid.raider,tag=!smithed.entity,tag=!smithed.strict] at @s run execute if entity @e[type=area_effect_cloud,tag=bastion_raid.spawner,distance=..64] run function bastion_raid:stats/convert_to_raider

#BASTION GOLEM SPAWN
execute if score bastion_raid.sc bastion_raid.gol matches 1 run execute as @e[type=#bastion_raid:piglins,tag=bastion_raid.piglins,predicate=bastion_raid:location/bastion,predicate=!bastion_raid:angry,predicate=bastion_raid:chance_20,limit=1,sort=random,nbt=!{IsBaby:1b}] at @s run execute unless entity @e[type=iron_golem,tag=bastion_raid.golem,distance=..128] run execute unless entity @a[gamemode=!spectator,distance=..24] run function bastion_raid:spawn/bastion_golem

#RECREATE SPAWNERS IF WITHER SKELETONS AND PIGLINS
execute if score bastion_raid.sc bastion_raid.vis matches 1 run execute as @e[type=#bastion_raid:piglins,tag=bastion_raid.target,limit=8,sort=random] at @s run function bastion_raid:recreate

#MOB GRIEFING GAMERULE
execute store result score bastion_raid.sc bastion_raid.gri run gamerule mobGriefing

#REMOVE RAID IN PROGRESS IF NOT IN BASTION
execute as @a[advancements={bastion_raid:raid/in_progress=true},predicate=!bastion_raid:location/bastion] at @s run advancement revoke @s only bastion_raid:raid/in_progress

#WITHER SKELETON RAIDERS DIG
execute if score bastion_raid.sc bastion_raid.gri matches 1 run execute if score bastion_raid.sc bastion_raid.vis matches 1 run execute as @e[type=wither_skeleton,tag=bastion_raid.raider,predicate=bastion_raid:angry,predicate=bastion_raid:chance_75,sort=random,limit=3] at @s run execute unless block ~ ~1 ~ lava unless block ~ ~ ~ lava run fill ~1 ~1 ~1 ~-1 ~1 ~-1 air destroy
execute if score bastion_raid.sc bastion_raid.gri matches 1 run execute if score bastion_raid.sc bastion_raid.vis matches 1 run execute as @e[type=wither_skeleton,tag=bastion_raid.raider,predicate=bastion_raid:angry,predicate=bastion_raid:chance_75,sort=random,limit=3] at @s run execute unless block ~ ~1 ~ lava unless block ~ ~ ~ lava run fill ~2 ~4 ~2 ~-2 ~2 ~-2 air destroy
schedule function bastion_raid:delete_items 2t

#DELETE UNRENDERABLE RAIDERS
execute as @e[type=wither_skeleton,tag=bastion_raid.entity] at @s run execute unless entity @e[type=#bastion_raid:piglins,tag=bastion_raid.target,distance=..1000] run tag @s remove bastion_raid.entity
execute as @e[type=wither_skeleton,tag=bastion_raid.raider] at @s run execute unless entity @e[type=#bastion_raid:piglins,tag=bastion_raid.target,distance=..1000] run tag @s remove bastion_raid.raider

#RAIDER WITHER SKELETONS GLOW
execute if score bastion_raid.sc bastion_raid.vis matches 1 run execute if predicate bastion_raid:chance_30 run effect give @e[type=wither_skeleton,tag=bastion_raid.raider] glowing 5 0 true
execute if score bastion_raid.sc bastion_raid.vis matches 1 run effect give @e[type=!player,tag=bastion_raid.target] glowing 2 0 true

#REMOVE PLAYER FROM ALLY
execute as @a[scores={bastion_raid.ali=1}] at @s run execute unless entity @e[type=area_effect_cloud,tag=bastion_raid.spawner,distance=..128] run execute unless entity @e[type=wither_skeleton,tag=bastion_raid.entity,distance=..128] run execute unless entity @e[type=#bastion_raid:piglins,tag=bastion_raid.target,distance=..128] run scoreboard players reset @s bastion_raid.ali

#INVISIBILITY TAG
effect give @e[tag=bastion_raid.invisible] invisibility 999999 0 true

#CHUNKLOADING
execute if score bastion_raid.sc bastion_raid.vis matches 1 run execute as @e[type=wither_skeleton,tag=bastion_raid.raider,limit=3,sort=random] at @s run execute unless entity @e[type=armor_stand,tag=bastion_raid.loader,distance=..16] run function bastion_raid:spawn/chunkloader
execute if score bastion_raid.sc bastion_raid.vis matches 1 run execute as @e[type=#bastion_raid:piglins,tag=bastion_raid.target,limit=3,sort=random] at @s run execute unless entity @e[type=armor_stand,tag=bastion_raid.loader,distance=..16] run function bastion_raid:spawn/chunkloader

#REMOVE WARN AND TIMEOUT TAG
execute as @e[type=!player,tag=bastion_raid.warn] at @s run execute if entity @a[distance=..256] run tag @s remove bastion_raid.warn
execute as @e[type=!player,tag=bastion_raid.timeout] at @s run execute if entity @a[distance=..256] run tag @s remove bastion_raid.timeout

#ADD WARN TAG
execute as @e[type=#bastion_raid:piglins,tag=bastion_raid.target,tag=!bastion_raid.warn] at @s run execute unless entity @a[distance=..256] run tag @s add bastion_raid.warn

#REMOVE LAVA FROM BASTION REMNANTS
execute as @e[type=#bastion_raid:piglins,limit=9,sort=random,predicate=bastion_raid:location/bastion,tag=bastion_raid.piglins] at @s run fill ~15 ~15 ~15 ~-15 ~-15 ~-15 blackstone replace lava[level=0]
execute as @e[type=#bastion_raid:piglins,limit=9,sort=random,predicate=bastion_raid:location/bastion,tag=bastion_raid.piglins] at @s run fill ~15 ~15 ~15 ~-15 ~-15 ~-15 blackstone replace magma_block
execute as @e[type=#bastion_raid:piglins,limit=9,sort=random,predicate=bastion_raid:location/bastion,tag=bastion_raid.piglins] at @s run fill ~15 ~15 ~15 ~-15 ~-15 ~-15 respawn_anchor[charges=4] replace spawner

#CLEAR CHUNKLOADER
execute unless score bastion_raid.sc bastion_raid.vis matches 1 run function bastion_raid:clear_chunkloader